package bintools

import com.icodici.ubdata.Varint
import net.sergeych.bintools.encodeToHex
import kotlin.test.Test
import kotlin.test.assertEquals

class VarintTest {

    fun testValue(x: Long) {
        assertEquals(x.toULong(), Varint.decode(Varint.encode(x.toULong())))
        assertEquals(x, Varint.decodeSigned(Varint.encodeSigned(x)))
        println("+ ${x}: ${Varint.encode(x.toULong()).encodeToHex()}")
    }

    fun testAround(bits: Int) {
        val window = 5
        var median: Long = (1.toULong() shl bits).toLong()
        for( x in (median-5)..(median+5)) {
            testValue(x)
        }
        median = median * 3 / 2
        for( x in (median-5)..(median+5)) {
            testValue(x)
        }
    }

    @Test
    fun encode() {
//        for( i in 0..300) testValue(i.toLong())
        testAround(7)
        testAround(14)
        testAround(21)
        testAround(28)
    }

    @Test
    fun decode() {
    }
}